> For a complete documentation index, fetch https://docs.voximplant.ai/llms.txt # CreateCallList POST https://api.voximplant.com/platform_api/CreateCallList Content-Type: multipart/form-data Adds a new CSV file for call list processing and starts the specified rule immediately. To send a file, use the request body. To set the call time constraints, use the following options in a CSV file: **\_\_start\_execution\_time** – when the call list processing starts every day, UTC+0 24-h format: HH:mm:ss**\_\_end\_execution\_time** – when the call list processing stops every day, UTC+0 24-h format: HH:mm:ss**\_\_start\_at** – when the call list processing starts, UNIX timestamp. If not specified, the processing starts immediately after a method call**\_\_task\_uuid** – call list UUID. A string up to 40 characters, can contain latin letters, digits, hyphens (-) and colons (:). Unique within the call list This method accepts CSV files with custom delimiters, such a commas (,), semicolons (;) and other. To specify a delimiter, pass it to the **delimiter** parameter. **IMPORTANT:** the account's balance should be equal or greater than 1 USD. If the balance is lower than 1 USD, the call list processing does not start, or it stops immediately if it is active. Allowed roles: `Owner`, `Admin`, `Developer`, `Call list manager`. Reference: https://docs.voximplant.ai/api-reference/management-api/reference/call-lists/create-call-list ## Authentication - `Authorization` header (bearer token, required) — Voximplant Management API uses signed JWT tokens generated from your service-account private key. Pass the token in the `Authorization` header as a Bearer value: ``` Authorization: Bearer $VOXIMPLANT_TOKEN ``` See [Authorization](/api-reference/management-api/authorization) for ready-to-copy snippets in bash, Python, Node.js and Go that turn your `credentials.json` into a token. ## Request ### Query parameters - `rule_id` (integer, required) — Rule ID. It is specified in the Applications section of the Control Panel - `priority` (integer, required) — Call list priority. The value is in the range of [0 ... 2^31] where zero is the highest priority - `max_simultaneous` (integer, required) — Number of simultaneously processed tasks - `num_attempts` (integer, required) — Number of attempts. Minimum is **1**, maximum is **5** - `name` (string, required) — File name, up to 255 characters and cannot contain the '/' and '\' symbols - `interval_seconds` (integer, optional) — Interval between call attempts in seconds. The default value is 0 - `encoding` (string, optional) — Encoding file. The default value is UTF-8 - `delimiter` (string, optional) — Separator values. The default value is ';' - `escape` (string, optional) — Escape character for parsing csv - `reference_ip` (string, optional) — IP from the geolocation of the call list subscribers. It allows selecting the nearest server for serving subscribers - `server_location` (string, optional) — Location of the server where the scenario needs to be executed. Has higher priority than `reference_ip`. Request [getServerLocations](https://api.voximplant.com/getServerLocations) for possible values - `task_priority_strategy` (string, optional) — Optional. Whether to prioritize first calling attempts or repeated ones. The possible values are: first_attempts, repeated_attempts. The default values is first_attempts. ### Body (multipart/form-data) This endpoint expects a multipart form containing a file. - `file_content` (file, required) — Send as the "body" part of the HTTP request or as multiform. The sending "file_content" via URL is at its own risk because the network devices tend to drop HTTP requests with large headers ## Response ### 200 Successful response - `result` (boolean, optional) — Whether the request completed successfully - `count` (integer, optional) — Number of stored records - `list_id` (integer, optional) — List ID - `batch_id` (string, optional) — Batch UUID ## Examples **Request** ```json { "file_content": "" } ``` **Response** ```json { "result": true, "count": 150, "list_id": 2345, "batch_id": "a3f1c9d2-7b4e-4f8a-9c3d-2e5b7f8a9d12" } ``` **SDK Code** ```python Example 1 import requests url = "https://api.voximplant.com/platform_api/CreateCallList" querystring = {"rule_id":"1","priority":"1","max_simultaneous":"1","num_attempts":"1","name":"name"} files = { "file_content": "open('call_list_202406.csv', 'rb')" } headers = {"Authorization": "Bearer "} response = requests.post(url, files=files, headers=headers, params=querystring) print(response.json()) ``` ```javascript Example 1 const url = 'https://api.voximplant.com/platform_api/CreateCallList?rule_id=1&priority=1&max_simultaneous=1&num_attempts=1&name=name'; const form = new FormData(); form.append('file_content', 'call_list_202406.csv'); const options = {method: 'POST', headers: {Authorization: 'Bearer '}}; options.body = form; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go Example 1 package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://api.voximplant.com/platform_api/CreateCallList?rule_id=1&priority=1&max_simultaneous=1&num_attempts=1&name=name" payload := strings.NewReader("-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"file_content\"; filename=\"call_list_202406.csv\"\r\nContent-Type: application/octet-stream\r\n\r\n\r\n-----011000010111000001101001--\r\n") req, _ := http.NewRequest("POST", url, payload) req.Header.Add("Authorization", "Bearer ") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby Example 1 require 'uri' require 'net/http' url = URI("https://api.voximplant.com/platform_api/CreateCallList?rule_id=1&priority=1&max_simultaneous=1&num_attempts=1&name=name") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["Authorization"] = 'Bearer ' request.body = "-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"file_content\"; filename=\"call_list_202406.csv\"\r\nContent-Type: application/octet-stream\r\n\r\n\r\n-----011000010111000001101001--\r\n" response = http.request(request) puts response.read_body ``` ```java Example 1 import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://api.voximplant.com/platform_api/CreateCallList?rule_id=1&priority=1&max_simultaneous=1&num_attempts=1&name=name") .header("Authorization", "Bearer ") .body("-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"file_content\"; filename=\"call_list_202406.csv\"\r\nContent-Type: application/octet-stream\r\n\r\n\r\n-----011000010111000001101001--\r\n") .asString(); ``` ```php Example 1 request('POST', 'https://api.voximplant.com/platform_api/CreateCallList?rule_id=1&priority=1&max_simultaneous=1&num_attempts=1&name=name', [ 'multipart' => [ [ 'name' => 'file_content', 'filename' => 'call_list_202406.csv', 'contents' => null ] ] 'headers' => [ 'Authorization' => 'Bearer ', ], ]); echo $response->getBody(); ``` ```csharp Example 1 using RestSharp; var client = new RestClient("https://api.voximplant.com/platform_api/CreateCallList?rule_id=1&priority=1&max_simultaneous=1&num_attempts=1&name=name"); var request = new RestRequest(Method.POST); request.AddHeader("Authorization", "Bearer "); request.AddParameter("undefined", "-----011000010111000001101001\r\nContent-Disposition: form-data; name=\"file_content\"; filename=\"call_list_202406.csv\"\r\nContent-Type: application/octet-stream\r\n\r\n\r\n-----011000010111000001101001--\r\n", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift Example 1 import Foundation let headers = ["Authorization": "Bearer "] let parameters = [ [ "name": "file_content", "fileName": "call_list_202406.csv" ] ] let boundary = "---011000010111000001101001" var body = "" var error: NSError? = nil for param in parameters { let paramName = param["name"]! body += "--\(boundary)\r\n" body += "Content-Disposition:form-data; name=\"\(paramName)\"" if let filename = param["fileName"] { let contentType = param["content-type"]! let fileContent = String(contentsOfFile: filename, encoding: String.Encoding.utf8) if (error != nil) { print(error as Any) } body += "; filename=\"\(filename)\"\r\n" body += "Content-Type: \(contentType)\r\n\r\n" body += fileContent } else if let paramValue = param["value"] { body += "\r\n\r\n\(paramValue)" } } let request = NSMutableURLRequest(url: NSURL(string: "https://api.voximplant.com/platform_api/CreateCallList?rule_id=1&priority=1&max_simultaneous=1&num_attempts=1&name=name")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```